<?php

namespace App\Enums;

use App\Filament\Support\CheerfulNotification;
use App\Traits\Enum\WithComment;
use App\Traits\Enum\WithValue;
use Filament\Support\Contracts\HasColor;
use Filament\Support\Contracts\HasLabel;

enum DecisionAdmin: int implements HasColor, HasLabel
{
    use WithComment, WithValue;

    case APPROVED = 1;
    case NEED_REVISION = 2;
    case REJECTED = 3;

    public function getLabel(): ?string
    {
        return match ($this) {
            self::APPROVED => CheerfulNotification::getByKey('enum.decision_admin.approved'),
            self::NEED_REVISION => CheerfulNotification::getByKey('enum.decision_admin.need_revision'),
            self::REJECTED => CheerfulNotification::getByKey('enum.decision_admin.rejected'),
        };
    }

    public function getColor(): string|array|null
    {
        return match ($this) {
            self::APPROVED => 'success',
            self::NEED_REVISION => 'info',
            self::REJECTED => 'danger',
        };
    }

    public static function options(): array
    {
        return collect(self::cases())
            ->mapWithKeys(fn ($case) => [$case->value => $case->getLabel()])
            ->toArray();
    }
}
